import { Plugin } from 'unified';

/**
 * This module walks through the node tree and does:
 * - gets the class name
 * - parses the class and extracts the highlight lines directive and the language name
 * - highlights the code using refractor
 * - if markers are present then:
 *    - converts AST to HTML
 *    - then applies some fixes to make line highlighting work with JSX found here: https://github.com/gatsbyjs/gatsby/blob/master/packages/gatsby-remark-prismjs/src/directives.js#L113-L119
 *    - add markers using: https://github.com/rexxars/react-refractor/blob/master/src/addMarkers.js
 *    - converts the code back from HTML to AST
 *  - sets the code as value
 */
interface Options {
    ignoreMissing?: boolean;
    markers?: number[];
    tagName?: string;
    className?: string;
    [k: string]: any;
}
declare const rehypeMetaAsAttributes: Plugin;
declare const rehypeHighlight: Plugin;

export { Options, rehypeHighlight, rehypeMetaAsAttributes };
